/**  
 * Copyright (c) 2012 Carnegie Mellon University. 
 *     All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
 * For more about this software visit:
 *
 *      http://www.graphlab.org
 *
 */
 
/**
 * @file cvv8.hpp Monolith header containing all cvv8 headers.
 * @author Jiunn Haur Lim <jiunnhal@cmu.edu>
 */

#ifndef GRAPHLAB_CVV8_HPP
#define GRAPHLAB_CVV8_HPP

#include <cvv8/v8-convert.hpp>
#include <cvv8/NativeToJSMap.hpp>
#include <cvv8/XTo.hpp>
#include <cvv8/ClassCreator.hpp>
#include <cvv8/properties.hpp>
#include <cvv8/arguments.hpp>
#include <cvv8/V8Shell.hpp>

#define JSTR(X) v8::String::New(X)

#endif // GRAPHLAB_CVV8_HPP
