/* 
 * Copyright (c) 2009 Carnegie Mellon University. 
 *     All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an "AS
 *  IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 *  express or implied.  See the License for the specific language
 *  governing permissions and limitations under the License.
 *
 * For more about this software visit:
 *
 *      http://www.graphlab.ml.cmu.edu
 *
 */

// This file contains the documentation for the matrix factorization
// toolkit.

/**
\defgroup toolkit_matrix_factorization Matrix Factorization

\section toolkit_matrix_factorization_intro Introduction

The GraphLab Matrix Factorization toolkit can be used for a wide range
of applications in collaborative filtering and recommendation
systems. Matrix factorization can be cast as a graph processing by
interpreting the typically sparse matrix as a graph and then treating
the vertices as rows and columns.  

In this library we have implemented the following initial algorithms:

\li Alternating Least Squares \ref als.cpp
\li Positive Singular Value Decomposition \ref svd.cpp


\todo Finish documenting the Matrix factorization toolkit description.





*/ 

